/*
 * Decompiled with CFR 0.152.
 * 
 * Could not load the following classes:
 *  fire.pb.PropRole
 *  mkdb.Lockeys
 *  mkdb.Procedure
 *  mkdb.TTable
 *  xbean.BattleInfo
 *  xbean.Fighter
 *  xtable.Battle
 *  xtable.Locks
 *  xtable.Roleid2teamid
 */
package fire.pb.battle;

import fire.pb.PropRole;
import fire.pb.battle.BattleEndHandler;
import fire.pb.battle.BattleField;
import fire.pb.battle.PBattleEnd;
import fire.pb.battle.PRoundPLayEnd;
import fire.pb.battle.PRoundStart;
import java.util.ArrayList;
import java.util.HashSet;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.Map;
import mkdb.Lockeys;
import mkdb.Procedure;
import mkdb.TTable;
import xbean.BattleInfo;
import xbean.Fighter;
import xtable.Battle;
import xtable.Locks;
import xtable.Roleid2teamid;

public class PRoundEnd
extends Procedure {
    private final long battleID;
    private final int round;

    PRoundEnd(long battleID, int round) {
        this.battleID = battleID;
        this.round = round;
    }

    public boolean process() {
        BattleInfo battle = Battle.get((Long)this.battleID);
        if (null == battle) {
            return false;
        }
        if (battle.getRound() != this.round) {
            return false;
        }
        HashSet<Long> teamids = new HashSet<Long>();
        Iterator iterator = battle.getRoleids().keySet().iterator();
        while (iterator.hasNext()) {
            long rid = (Long)iterator.next();
            Long tid = Roleid2teamid.select((Long)rid);
            if (tid == null) continue;
            teamids.add(tid);
        }
        this.lock(Lockeys.get((TTable)Locks.TEAMLOCK, teamids));
        this.lock(Lockeys.get((TTable)Locks.ROLELOCK, battle.getRoleids().keySet()));
        LinkedList roleids = new LinkedList();
        roleids.addAll(battle.getRoleids().keySet());
        Iterator rid = roleids.iterator();
        while (rid.hasNext()) {
            long rid2 = (Long)rid.next();
            if (battle.getFeedbacks().contains(rid2)) continue;
            new PRoundPLayEnd(rid2, new LinkedList<Integer>(), false).call();
        }
        ArrayList<Integer> rmIndex = new ArrayList<Integer>();
        BattleField.processFaileMonsters(battle, true);
        for (Map.Entry e : battle.getRoundresult().entrySet()) {
            long masterId;
            int petkey;
            int i = (Integer)e.getKey();
            Fighter fighter = (Fighter)battle.getFighters().get(i);
            if (fighter == null) {
                rmIndex.add(i);
                continue;
            }
            if (BattleField.checkOutBattle(battle, i)) {
                try {
                    int petkey2 = -1;
                    if (fighter.getFightertype() == 2) {
                        int masterIndex = i - 5;
                        petkey2 = new PropRole(((Fighter)battle.getFighters().get(masterIndex)).getUniqueid(), true).getFightpetkey();
                    }
                    for (BattleEndHandler handler : battle.getBattleendhandlers()) {
                        handler.processOutBattle(i, petkey2);
                        rmIndex.add(i);
                    }
                    continue;
                }
                catch (Exception ex) {
                    BattleField.logger.debug((Object)"Runaway handle failed", (Throwable)ex);
                    continue;
                }
            }
            if (fighter.getFightertype() == 2 && (petkey = new PropRole(masterId = ((Fighter)battle.getFighters().get(i - 5)).getUniqueid(), true).getFightpetkey()) >= 0) continue;
        }
        Iterator rid2 = rmIndex.iterator();
        while (rid2.hasNext()) {
            int i = (Integer)((Object)rid2.next());
            battle.getRoundresult().remove(i);
        }
        if (battle.getBattleresult() != 2) {
            PRoundEnd.pexecuteWhileCommit((Procedure)new PBattleEnd(this.battleID, battle.getBattleresult()));
            return true;
        }
        battle.getDecisions().clear();
        battle.getFeedbacks().clear();
        battle.getSkipeddeadfighters().clear();
        this.clearResult(battle);
        BattleField.sendRoundChangeResult(battle);
        battle.getProtectormap().clear();
        if (BattleField.logger.isDebugEnabled()) {
            BattleField.logger.debug((Object)("当前回合结束了,还有战斗者数量:\t" + battle.getFighters().size()));
        }
        ArrayList<Long> liveRoleids = new ArrayList<Long>();
        liveRoleids.addAll(battle.getRoleids().keySet());
        new PRoundStart(this.battleID, liveRoleids).call();
        return true;
    }

    private void clearResult(BattleInfo battle) {
        Map roundresult = battle.getRoundresult();
        for (Integer i : roundresult.keySet()) {
            if (BattleField.checkLiveInBattle(battle, i)) {
                roundresult.put(i, 0);
                continue;
            }
            Integer val = (Integer)battle.getRoundresult().get(i);
            if (null == val) {
                return;
            }
            int result = 0;
            if ((val & 0x2000) != 0) {
                result += 8192;
            }
            if ((val & 0x8000) != 0) {
                result += 32768;
            }
            roundresult.put(i, result);
        }
    }
}

